<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';

require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . '/user_management/check_username_availability.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'admin_api/academic_session/functions/registration_functions.php';

require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//get student
require_once $base_path_to_learning_resources . 'lib/common_modules/students/functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);

if (
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token']) or
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'],null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}


if ($postdata['function_type']  == "fetch_students_gatepass") {
    $institution_id = trim($postdata['institution_id']);
    $check_academic_confirmation_id = CheckAcademicSession($conn_rjllearning_specific, $institution_id);

    if ($check_academic_confirmation_id != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
    if (isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
        $branch_id = trim($postdata['branch_id']);
    } else {
        $branch_id = "all";
    }
    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = "all";
    }
    if (isset($postdata['section_id']) and !empty($postdata['section_id']) and trim($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = "all";
    }

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    // $additionaldata = array(
    //     'id','admission_id', 'admission_number', 'name', 'mobile', 'email', 'dob', 'fathername', 'gender', 'user_id'
    // );
    $additionaldata = ['id', 'institution_id', 'branch_id', 'admission_id', 'admission_number', 'name', 'mobile', 'email', 'dob', 'fathername', 'gender', 'can_activate', 'user_id','father_occupation','mother_occupation','username'];


    if($branch_id == "all"){
    // Ensure 'branch_id' is always included
        if (!in_array('branch_id', $postdata['additional_data'])) {
            $postdata['additional_data'][] = 'branch_id';
        }
    }

    $additionaldata = array_merge($additionaldata, $postdata['additional_data']);

    $limit = $postdata['limit'];

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {
        $offset = null;
    }
    
    $success['data'] = get_students_detail_gatepass($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $search_string, $limit, $offset, $additionaldata);
    successreturn($success);
}
